package logic

import (
	"context"
	"errors"
	"leafdev.top/leaf/rag/ent"
	"leafdev.top/leaf/rag/ent/library"
	"leafdev.top/leaf/rag/internal/providers"
)

type LibraryLogic struct {
}

var client = providers.MustGet[ent.Client]()

func NewLibraryLogic() *LibraryLogic {
	return &LibraryLogic{}
}

func (l *LibraryLogic) ListLibrary(ctx context.Context) ([]*ent.Library, error) {
	return client.Library.Query().Where(library.UserID(GetUserId(ctx))).All(ctx)
}

func (l *LibraryLogic) CreateLibrary(ctx context.Context, name string) (*ent.Library, error) {
	// name 不能为空
	if name == "" {
		return nil, errors.New("名称不能为空")
	}

	return client.Library.Create().
		SetName(name).
		SetUserID(GetUserId(ctx)).
		Save(ctx)
}
